// global variables
var mgMouseService = false;
var mgNativeTrails = false;
var mgMouseEvents = false;

var mgComponentLoader = {
  init : false,

  initMouseService : function(setMain) {
    if (this.init)
      return;

    this.init = true;

    if (("@mousegestures.org/mgMouseService;1" in Components.classes)) {
      try {
        mgMouseService = Components.classes["@mousegestures.org/mgMouseService;1"]
                         .getService().QueryInterface(Components.interfaces.mgIMouseService);

        mgNativeTrails = mgMouseService.supports("nativeTrails");
        mgMouseEvents = mgMouseService.supports("mouseEvents");

        if (setMain) {
          var baseWin = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                              .getInterface(Components.interfaces.nsIWebNavigation)
                              .QueryInterface(Components.interfaces.nsIBaseWindow);

          mgMouseService.setMainWin(baseWin);
        }
      }
      catch (e) {}
    }
  }
}

var _mgMS = Components.classes["@mousegestures.org/mgMappingsService;1"].getService();
_mgMS = _mgMS.wrappedJSObject;
_mgMS.initMappings();