var mgWindowType = false;
var mgStatusSetter;

var mgWindowTypes =
{
  wTypes : new Array(),
  setter : new Array(),

  init : function() {
    var w = this.wTypes;
    //SM-Toolkit is indented
    w["chrome://browser/content/browser.xul"]                             = ["browser"]
      w["chrome://navigator/content/navigator.xul"]                       = ["browser"]
    w["chrome://global/content/viewSource.xul"]                           = ["viewsource"]
    w["chrome://global/content/viewPartialSource.xul"]                    = ["viewsource"]
      w["chrome://navigator/content/viewSource.xul"]                      = ["viewsource"]
      w["chrome://navigator/content/viewPartialSource.xul"]               = ["viewsource"]
    w["chrome://messenger/content/messenger.xul"]                         = ["messenger"]
    w["chrome://messenger/content/messageWindow.xul"]                     = ["messenger"]
    w["chrome://messenger/content/messengercompose/messengercompose.xul"] = ["mailcompose"]
    w["chrome://chatzilla/content/chatzilla.xul"]                         = ["chatzilla"]

    var s = this.setter;
    s["browser"]    = {contentAreaGetter  : "getBrowser()",
                       autoScrollGetter   : "getBrowser().mCurrentBrowser",
                       statusGetter       : "statusbar-display"}
    s["viewsource"] = {contentAreaGetter  : "document.getElementById('content')",
                       autoScrollGetter   : "document.getElementById('content')",
                       statusGetter       : "statusbar-line-col",
                       statusGetter1      : "appcontent"}
    s["messenger"]  = {contentAreaGetter  : "document.getElementById('messagepane')",
                       autoScrollGetter   : "document.getElementById('messagepane')",
                       statusGetter       : "statusText"}
    s["mailcompose"]= {contentAreaGetter  : "document.getElementById('content-frame')",
                       autoScrollGetter   : null,
                       statusGetter       : "statusText"}
    s["chatzilla"]  = {contentAreaGetter  : "document.getElementById('output-deck')",
                       autoScrollGetter   : "document.getElementById('output-deck').firstChild",
                       statusGetter       : "status-text"}
  },

  setIt : function() {
    if (document.getElementById("mgStatusSetter"))
      return;

    mgStatusSetter = document.getElementById(mgWindowTypes.setter[mgWindowType].statusGetter)

    var panel = document.createElement("statusbarpanel")
    panel.id = "mgStatusSetter"
    var label = document.createElement("label")
    label.id = "mgStatusLabel"
    label.setAttribute("crop", "end")
    label.setAttribute("value", "")
    panel.appendChild(label)

    if (mgStatusSetter) {
      mgStatusSetter.parentNode.insertBefore(panel, mgStatusSetter)
      panel.hidden = true
    }
    else if ("statusGetter1" in mgWindowTypes.setter[mgWindowType]){
      var sets = document.getElementsByTagName("statusbar");
      var set;

      if (sets && sets.length > 0)
        set = sets[0];
      else {
        set = document.createElement("statusbar")
        sets[0] = document.getElementById(mgWindowTypes.setter[mgWindowType].statusGetter1)
        panel.setAttribute("flex", 1)
        panel.mgIsMaster = true
      }
      sets[0].appendChild(set)
      set.insertBefore(panel, set.firstChild)
    }
    mgStatusSetter = panel
  },

  getWindowType : function(location) {
    return (location in this.wTypes) ? this.wTypes[location] : false;
  }
}

function mgGetContentArea() {
  return eval(mgWindowTypes.setter[mgWindowType].contentAreaGetter);
}

function mgStopAutoScroll() {
  var aScroll = eval(mgWindowTypes.setter[mgWindowType].autoScrollGetter);
  if (aScroll && aScroll.autoscrollEnabled) {
    aScroll.stopScroll();
    try {
      if (aScroll._autoScrollPopup)
        aScroll._autoScrollPopup.hidePopup();
    }
    catch (e) {}
    return true;
  }
  else
    return false;
}